<?php
if (file_exists("config_db.inc.php")) {
  include("config_db.inc.php");
  ## copyright  2000-2001 Albrecht Guenther  ag@phprojekt.com
  ## www.phprojekt.com
  ## modified by Andreas Kansok andreas@kansok.com
  ## www.kansok.com
  // Connect
  if ( $db_type == "mysql" ) {
    $dbIDnull = "null";
    $link = mysql_connect($db_host, $db_user, $db_pass) or mysql_error();
    $conn = mysql_select_db($db_name);
  }
  elseif ( $db_type == "interbase" ) {
    $dbIDnull = "null";
    $db_host2 = "$db_host:$db_name";
    $link = ibase_connect($db_host2, $db_user, $db_pass);
  }
  elseif ( $db_type == "postgresql" ) {
    $dbIDnull = "pgnull";
    $link = pg_connect("$db_host","5432","$db_name") or pg_errormessage();
  }
  elseif ( $db_type == "odbc" ) {
    $dbIDnull = "null";
    $link = odbc_connect($db_name, $db_user, $db_pass);
  }
  elseif ( $db_type == "oracle" ) {
    $dbIDnull = "null";
    $link = OCILogon($db_user, $db_pass, $db_name);
    $datestmt = OCIParse($link, "alter session set NLS_DATE_FORMAT='YYYY-MM-DD HH:MI:SS'");
    OCIExecute($datestmt);
  }
  elseif ( $db_type == "informix" ) {
    $dbIDnull = "0";
    if ($db_host == "") $db = $db_name; else $db = $db_name."@".$db_host;
    $link = ifx_connect($db, $db_user, $db_pass);
  }
  elseif ( $db_type == "ms_sql" ) {
    $dbIDnull = "msnull";
    $link = mssql_connect($db_name, $db_user, $db_pass);
    $conn = mssql_select_db($db_name);
  }
  // end setup-part
  // Query Statement
function db_query($query, $rp=1) {
  global $db_type, $link, $stmt, $counter, $item, $f_row;
  $prefix="";
  $tables = array("abt", "abtinfo", "bestell", "cart", "color", "colorinfo", "currency", "item",
                  "iteminfo", "itemgr", "itemgrinfo", "language", "link", "online", "package", "packinfo", "payment", "price",
	          "pricetype", "shipment", "size", "sizeinfo", "statistics", "user", "usrgroup");
  foreach ($tables as $table)
  {
    if (ereg("\ ".$table, $query))
    {
      if ($table!="user") $query=preg_replace("/".$table."(?!([a-z]|ID|gr))/"," ".$prefix.$table, $query);
      else $query=preg_replace("/".$table."(?!([a-z]|ID|gr))/"," ".$prefix.$table, $query,1);
    }
  }
  if ($rp==3) echo "$query <br>\n";
  if ($db_type == "mysql"){
    return mysql_query($query);
  }
  elseif($db_type == "interbase") {
    return ibase_query($link, $query);
  }
  elseif ($db_type == "postgresql") {
    //get name of sequence
    if(preg_match("/INTO\s*(\w*)\s*/",$query,$matches)){$dbIDnull="nextval('" . $matches[1] . "_id_seq')"; }
    elseif(preg_match("/into\s*(\w*)\s*/",$query,$matches)){$dbIDnull="nextval('" . $matches[1] . "_id_seq')"; }
    $query=ereg_replace("pgnull", $dbIDnull,$query);
    $item++;
    $f_row[$item]=0;
    return pg_exec($link, $query);
  }
  elseif ($db_type == "odbc") {
    return odbc_exec($link, $query);
  }
  elseif ($db_type == "oracle") {
    $query1 = ereg_replace('&&',' and ',$query);
    $stmt =  OCIParse($link, $query1);
    OCIExecute($stmt);
    if (eregi('insert|update|delete',$query1)) {
      $commit_stmt = OCIParse($link, 'commit');
      OCIExecute($commit_stmt);
    }
    return $stmt;
  }
  elseif ($db_type == "informix") {
    $rid = ifx_prepare($query, $link);
    if (!ifx_do($rid)) {
      ifx_error();
    }
    return $rid;
  }
  elseif ($db_type == "ms_sql")  {
    $sPattern = 'msnull[ ]*,';
    $sNewQuery = eregi_replace($sPattern, '', $query);
    return mssql_query($sNewQuery);
  }
}


  // fetch row statement
  function db_fetch_row ($result) {
    global $db_type,$link,$item,$f_row;
    if ($db_type == "mysql")    {
      return @mysql_fetch_row($result);
    }
    elseif ($db_type == "interbase") {
      return ibase_fetch_row($result);
    }
    elseif ($db_type == "postgresql") {
      $f_row[$item]++;
      if($f_row[$item] > pg_numrows($result)){return 0;}
      else { return pg_fetch_row($result,($f_row[$item]-1));}
    }
    elseif ($db_type == "odbc") {
      return odbc_fetch_into($result, $row);
    }
    elseif ($db_type == "oracle") {
      OCIFetchInto($result, $row, OCI_RETURN_NULLS+OCI_RETURN_LOBS);
      return $row;
    }
    elseif ($db_type == "informix") {
      if ($row = ifx_fetch_row($result)) {
        $types = ifx_fieldtypes($result);
        $row = array_values($row);
      }
      return $row;
    }
    elseif ($db_type == "ms_sql")    {
      return mssql_fetch_row($result);
    }
  }

  function db_num_rows ($result) {
    global $db_type,$stmt;
    if ($db_type == "mysql") {return @mysql_num_rows($result);}
    elseif ($db_type == "interbase") {return ibase_num_fields($result);}
    elseif ($db_type == "postgressql") {return pg_NumRows($result);}
    elseif ($db_type == "odbc") {return odbc_num_rows($result);}
    elseif ($db_type == "oracle") {return OCIFetchStatement($stmt,$result);}
    elseif ($db_type == "informix") {return ifx_num_rows($result);}
    elseif ($db_type == "ms_sql") {return mssql_num_rows($result);}
  }

  // Error-Messages
  function db_die($line="") {
    global $db_type;
    if ($db_type == "mysql") { echo mysql_error(); }
    elseif ($db_type == "postgresql") {echo "pg_errormessage($link)";}
    elseif ($db_type == "oracle") {echo "OCIError($stmt)";}
    elseif ($db_type == "informix") {echo "ifx_error()";}
    elseif ($db_type == "ms_sql") { echo "mssql_get_last_message()";}
    if ($line!="") {echo "$line ";}
    echo "\n</body></html>";
    #exit;
  }
  $db_func_loaded="yes";
}
else {
  $db_func_loaded="no";
}
?>
